package com.trade.client.enterprise.customer.service;

import javax.servlet.http.HttpServletRequest;
import com.trade.client.enterprise.customer.domain.model.LoginUserInfo;

/**
 * token验证处理
 */
public interface ICTokenService {

    /**
     * 获取用户身份信息
     *
     * @return 用户信息
     */
    LoginUserInfo getLoginUser(HttpServletRequest request);

    /**
     * 设置用户身份信息
     * 
     * @param loginUser
     */
    void setLoginUser(LoginUserInfo loginUser);

    /**
     * 删除用户身份信息
     * 
     * @param token
     */
    void delLoginUser(String token);

    /**
     * 创建令牌
     *
     * @param loginUser 用户信息
     * @return 令牌
     */
    String createToken(LoginUserInfo loginUser);

    /**
     * 验证令牌有效期，相差不足20分钟，自动刷新缓存
     *
     * @param loginUser
     * @return 令牌
     */
    void verifyToken(LoginUserInfo loginUser);

    /**
     * 刷新令牌有效期
     *
     * @param loginUser 登录信息
     */
    void refreshToken(LoginUserInfo loginUser);
}
